class Cryptol < Formula
  desc "Domain-specific language for specifying cryptographic algorithms"
  homepage "https://www.cryptol.net/"
  # TODO: Try to switch `ghc@9.6` to `ghc` on next release
  # https://github.com/GaloisInc/cryptol/issues/1624
  url "https://hackage.haskell.org/package/cryptol-3.1.0/cryptol-3.1.0.tar.gz"
  sha256 "f2590f15b0119de5510eca2d02a58a399771bf4224f5a3cc9b8ec90aeb050b03"
  license "BSD-3-Clause"
  head "https://github.com/GaloisInc/cryptol.git", branch: "master"

  depends_on "cabal-install" => :build
  depends_on "ghc@9.6" => :build
  depends_on "z3"

  uses_from_macos "ncurses"
  uses_from_macos "zlib"

  def install
    system "cabal", "v2-update"
    system "cabal", "v2-install", *std_cabal_v2_args
  end

  test do
    (testpath/"helloworld.icry").write <<~EOS
      :prove \\(x : [8]) -> x == x
      :prove \\(x : [32]) -> x + zero == x
    EOS
    expected = /Q\.E\.D\..*Q\.E\.D/m
    assert_match expected, shell_output("#{bin}/cryptol -b helloworld.icry")
  end
end
